#pragma once

// STD/STL
#include <memory>

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>
#include <RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h>

namespace armarx::armem::server::ltm
{
    class Extractor;
    typedef std::shared_ptr<Extractor> ExtractorPtr;

    class Extractor
    {
    public:
        struct Extraction
        {
            aron::data::DictPtr dataWithoutExtraction;
            std::map<std::string, aron::data::VariantPtr> extraction;
        };

        Extractor() = default;
        virtual ~Extractor() = default;

        virtual Extraction extract(aron::data::DictPtr& data) = 0;
        virtual aron::data::DictPtr merge(Extraction& encoding) = 0;
    };
}
