#pragma once

#include "../SkillDescription.h"
#include "../SkillStatusUpdate.h"
#include "../Skill.h"

#include <RobotAPI/interface/skills/SkillManagerInterface.h>

namespace armarx
{
    namespace skills
    {
        namespace detail
        {
            class SkillImplementationWrapper
            {
            public:
                // fixed values. Do not change after skill instantiation
                const std::shared_ptr<Skill> skill;

                // Current execution status. Changes during execution
                // The status also holds the used parameterization
                mutable std::mutex skillStatusMutex;
                SkillStatusUpdate statusUpdate;

                // Task information. task is recreated every time the skill restarts
                mutable std::mutex executingMutex;
                std::thread task;

                SkillImplementationWrapper(const std::shared_ptr<skills::Skill> skill) :
                    skill(skill)
                {
                    reset();
                }

                SkillImplementationWrapper(const SkillImplementationWrapper& s) :
                    SkillImplementationWrapper(s.skill)
                {}

                void execute();
                void reset();

            protected:
                void updateStatus() const;
            };
        }
    }
}
